<template>

  <div v-show="hasStartedSessionBuilder">
    
    <builder-file-uploader @multiFileuploaded="multiFileuploaded"
                           @fileuploaded="fileuploaded" 
                           @audiouploaded="audiouploaded" 
                           :info="triggerInfo"></builder-file-uploader>

    <draggable element="div" :class="dragStyle" v-model="list" :options="options">
      <component 
                 @toggleaudiogallery="togglegallery"
                 @togglegallery="togglegallery"
                 ref="`builder-${index}`"
                 :uploadableindexin="getUploadableIndexInCurrentSession(item)"
                 :uploadableindex="getUploadableIndexUntilCurrentSession(item)"
                 :fileuploadedinfo="file_uploaded_info"
                 :index="index" 
                 :length="list.length" 
                 :value="item.value" 
                 :is="item.component" 
                 :key="index" 
                 v-for="(item, index) in list" 
                 @remove="list.splice(index, 1)"></component>
    </draggable>
  </div>
</template>

<script>

import draggable from 'vuedraggable'
import { mapGetters, mapActions } from 'vuex'
import componentList from '../../../utils/ComponentManager'
import BuilderFileUploader from './BuilderFileUploader/index'

/** 
 * Contenedores de Lectura
 *                                   
 * Lecture Containers
 */

import sle01 from '../../CourseBuilder/Containers/sle01/builder.vue'
import sle02 from '../../CourseBuilder/Containers/sle02/builder.vue'
import sle03 from '../../CourseBuilder/Containers/sle03/builder.vue'
import sle04 from '../../CourseBuilder/Containers/sle04/builder.vue'
import sle05 from '../../CourseBuilder/Containers/sle05/builder.vue'
import sle06 from '../../CourseBuilder/Containers/sle06/builder.vue'
import sle07 from '../../CourseBuilder/Containers/sle07/builder.vue'
import sle08 from '../../CourseBuilder/Containers/sle08/builder.vue'
import sle09 from '../../CourseBuilder/Containers/sle09/builder.vue'
import sle10 from '../../CourseBuilder/Containers/sle10/builder.vue'

/** 
 * Contenedores Multimedia
 *                                   
 * Multimedia Containers
 */

import smu01 from '../../CourseBuilder/Containers/smu01/builder.vue'
import smu02 from '../../CourseBuilder/Containers/smu02/builder.vue'
import smu03 from '../../CourseBuilder/Containers/smu03/builder.vue'
import smu04 from '../../CourseBuilder/Containers/smu04/builder.vue'
import smu05 from '../../CourseBuilder/Containers/smu05/builder.vue'
import smu06 from '../../CourseBuilder/Containers/smu06/builder.vue'
import smu07 from '../../CourseBuilder/Containers/smu07/builder.vue'
import smu08 from '../../CourseBuilder/Containers/smu08/builder.vue'
import smu09 from '../../CourseBuilder/Containers/smu09/builder.vue'

/** 
 * Contenedores Evaluativos
 *                                   
 * Eval Containers
 */


import srp01 from '../../CourseBuilder/Containers/srp01/builder.vue'
import srp02 from '../../CourseBuilder/Containers/srp02/builder.vue'
import srp03 from '../../CourseBuilder/Containers/srp03/builder.vue'
import srp04 from '../../CourseBuilder/Containers/srp04/builder.vue'
import srp05 from '../../CourseBuilder/Containers/srp05/builder.vue'

export default {
  name: 'DragZone',
  components: {
    draggable, BuilderFileUploader,
    sle01, sle02, sle03, sle04, sle05, sle06, sle07, sle08, sle09, sle10,
    smu01, smu02, smu03, smu04, smu05, smu06, smu07, smu08, smu09,
    srp01, srp02, srp03, srp04, srp05
  },
  data() {
    return {
      file_uploaded_info: {},
      triggerInfo : {trigger: -1, mediaIndex: -1},
      options: { group: { name: 'items', pull: 'move' }, draggable: '.frame-content', ghostClass: 'ghost' },
    }
  },
  computed: {
    dragStyle() {
      return this.list.length > 0 ? 'frame-content-filled' : this.isDragging ? 'frame-content-dragging' : 'frame-content-empty'
    },
    list: {
      get() {
        return this.courseBuilderList
      },
      set(item) {
        this.updateCourseBuilderList(item)
      }
    },
    ...mapGetters([
      'hasStartedSessionBuilder',
      'courseBuilderList',
      'isDragging',
      'uploadableComponentsInCurrentSession',
      'uploadableComponentsUntilCurrentSession',
    ]),
  },
  methods: {
    getUploadableIndexInCurrentSession(item){
      return this.uploadableComponentsInCurrentSession.findIndex( element =>  element == item )
    },
    getUploadableIndexUntilCurrentSession(item){
      return this.uploadableComponentsUntilCurrentSession.findIndex( element =>  element == item )
    },
    togglegallery(triggerInfo){
      this.triggerInfo = triggerInfo
    },
    fileuploaded(file_uploaded_info){
      this.file_uploaded_info = file_uploaded_info
      d = new Date()
      this.$set(this.list[this.file_uploaded_info.index].value, 'img' , `/storage/${this.file_uploaded_info.path}?${d.getTime()}`)
      this.$set(this.list[this.file_uploaded_info.index].value, 'imgType' , `${this.file_uploaded_info.imgtype}`)
    }, 
    multiFileuploaded(file_uploaded_info){
      this.file_uploaded_info = file_uploaded_info
      d = new Date()
      let audio_index = this.file_uploaded_info.multiple_index
      let container_index = this.file_uploaded_info.index
      this.$set(this.list[container_index].value.audios[audio_index], 'img' , `/storage/${this.file_uploaded_info.path}?${d.getTime()}`)
      this.$set(this.list[container_index].value.audios[audio_index], 'imgType' , `${this.file_uploaded_info.imgtype}`)
    }, 
    audiouploaded(file_uploaded_info){
      this.file_uploaded_info = file_uploaded_info
      d = new Date()
      let audio_index = this.file_uploaded_info.multiple_index
      let container_index = this.file_uploaded_info.index
      this.$set(this.list[container_index].value.audios[audio_index], 'audio' ,([`/storage/${this.file_uploaded_info.path}`]))
      //this.$set(this.list[container_index].value.audios[audio_index], 'audio' ,([`/storage/${this.file_uploaded_info.path}`]))
      //this.$set(this.list[this.file_uploaded_info.index].value, 'imgType' , `/storage/${this.file_uploaded_info.imgtype}`) TIPO DE AUDIO (future feature)
    }, 
    ...mapActions([
      'updateCourseBuilderList',
      'storeCourse',
    ]),
  }
}
</script>

<style>
.ghost {
  opacity: 0.5;
}

.frame-content-filled {
  list-style-type: none;
}

.frame-content-filled > li {
  margin-left: 45%;
}

.frame-content-dragging,
.frame-content-empty {
  list-style-type: none;
  padding: 20px;
  text-align: center;
  margin: 47px;
  border: 2px dashed #b8babd;
  color: #b8babd;
  display: block;
  min-height: 200px;
  background: #e0e1e4;
}

.frame-content-empty:before {
  content: "\e6de";
  font-family: "themify";
  font-size: 73px;
  display: block;
}

.frame-content-empty:after {
  content: "Arrastra aquí tu contenedor";
  font-size: 20px;
}
</style>